//+------------------------------------------------------------------+
//|                                                   LSMA trend.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property  copyright "mladen"
#property  link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_width1 1
#property indicator_width2 1

//
//
//
//
//

extern int LSMAPeriod =  35;
extern int LSMAPrice  =   0;
extern int ArrowCode  = 159; 

//
//
//
//
//

double trendOa[];
double trendDn[];
double trend[];
double lsma[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,trendOa); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,ArrowCode);
   SetIndexBuffer(1,trendDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,ArrowCode);
   SetIndexBuffer(2,trend);
   SetIndexBuffer(3,lsma);
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{ 
   int counted_bars=IndicatorCounted();
   int limit,i;


   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(i = limit; i >= 0; i--)
      {
         lsma[i] = 3.0*iMA(NULL,0,LSMAPeriod,0,MODE_LWMA,LSMAPrice,i)-2.0*iMA(NULL,0,LSMAPeriod,0,MODE_SMA,LSMAPrice,i);
         if (i==Bars-1) { trendOa[i] = 0; continue; }
                  trend[i]   = trend[i+1];
                  trendOa[i] = trendOa[i+1];
                  trendDn[i] = EMPTY_VALUE;
         if (lsma[i]>lsma[i+1]) trend[i] =  1;
         if (lsma[i]<lsma[i+1]) trend[i] = -1;
         if (trend[i] ==  1) { trendOa[i] += 0.01; }
         if (trend[i] == -1) { trendOa[i] -= 0.01; trendDn[i] = trendOa[i]; }
      }   
   return(0);
}      